//===============================================================================
// Microsoft patterns & practices Enterprise Library
// Application Block Software Factory
//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================

using System;
using System.Text;
using System.Configuration;
using System.Collections.Generic;
using System.Diagnostics;
using System.ComponentModel;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design;
using Microsoft.Practices.EnterpriseLibrary.Configuration.Design.Validation;

namespace AAD.ProvidersLibrary.Configuration.Design
{
	public sealed class ConfigurationDesignManager : Microsoft.Practices.EnterpriseLibrary.Configuration.Design.ConfigurationDesignManager
	{
		public override void Register(IServiceProvider serviceProvider)
		{
			CommandRegistrar cmdRegistrar = new CommandRegistrar(serviceProvider);
			cmdRegistrar.Register();
			NodeMapRegistrar nodeRegistrar = new NodeMapRegistrar(serviceProvider);
			nodeRegistrar.Register();
		}

		/// <summary>
		/// Initializes the AAD.ProvidersLibrary.
		/// </summary>
		/// <param name="serviceProvider">The a mechanism for retrieving a service object; that is, an object that provides custom support to other objects.</param>
		/// <param name="rootNode">The root node of the application.</param>
		/// <param name="section">The <see cref="ConfigurationSection"/> that was opened from the <see cref="Microsoft.Practices.EnterpriseLibrary.Common.Configuration.IConfigurationSource"/>.</param>
		protected override void OpenCore(IServiceProvider serviceProvider, ConfigurationApplicationNode rootNode, System.Configuration.ConfigurationSection section)
		{
			base.OpenCore(serviceProvider, rootNode, section);
			// TODO: This code is useful every time you add a new node to the AAD.ProvidersLibrary Design-Time. If the new node constains references to other existent nodes, <see cref="IConfigurationUIHierarchy"> is useful to find and them. Then you should verify if it is the node that you are searching for and assign it to the new node. 
			//IConfigurationUIHierarchy hierarchy = ServiceHelper.GetCurrentHierarchy(serviceProvider);
			//foreach (AAD.ProvidersLibraryNode node in hierarchy.FindNodesByType(typeof(AAD.ProvidersLibraryNode)))
			//{
			//    foreach (ReferentNodeType referentNode in hierarchy.FindNodesByType(typeof(ReferentNodeType)))
			//    {
			//        if (referentNode.Name == node.referentNodeName)
			//        {
			//            node.ReferentNode = referentNode;
			//            break;
			//        }
			//    }
			//}			
		}
	}
}
